summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorRichard Maw <richard.maw@codethink.co.uk>2012-05-14 14:37:52 +0100
committerRichard Maw <richard.maw@codethink.co.uk>2012-05-14 16:35:51 +0100
commit68d045c68b51d1675b3aeb72c301b00a6af10021 (patch)
tree29ef68637dd47e2ba77a29491939453a34cb4463 /tests
parentbc69a6e4f9eb6c9e317134aa6515349ae3ed9691 (diff)
downloadmorph-68d045c68b51d1675b3aeb72c301b00a6af10021.tar.gz
builder: log to warnings when artifacts overlap
It may be better to print it to the console, but that requires getting self.msg set
Diffstat (limited to 'tests')
-rwxr-xr-xtests/stratum-overlap.script101
-rw-r--r--tests/stratum-overlap.stdout20
2 files changed, 121 insertions, 0 deletions
diff --git a/tests/stratum-overlap.script b/tests/stratum-overlap.script
new file mode 100755
index 00000000..442704a8
--- /dev/null
+++ b/tests/stratum-overlap.script
@@ -0,0 +1,101 @@
+#!/bin/sh
+#
+# If a stratum has multiple chunks that have the same files in them,
+# then this should be notified
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+cache="$DATADIR/cache/artifacts"
+chunkrepo="$DATADIR/chunk-repo"
+morphsrepo="$DATADIR/morphs-repo"
+log="$DATADIR/morph.log"
+
+cd "$morphsrepo"
+git checkout --quiet -b overlap master
+cat <<EOF >overlap-stratum.morph
+{
+ "name": "overlap-stratum",
+ "kind": "stratum",
+ "sources": [
+ {
+ "name": "overlap-foo-baz",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "overlap-foobar",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "overlap-fooqux",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ }
+ ]
+}
+EOF
+git add overlap-stratum.morph
+git commit --quiet -m "add overlapping stratum"
+
+cd "$chunkrepo"
+git checkout --quiet -b overlap master
+cat <<EOF >overlap-foo-baz.morph
+{
+ "name": "overlap-foo-baz",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/bin",
+ "for f in foo bar baz; do echo echo \$f >\$DESTDIR/bin/\$f; done"
+ ]
+}
+EOF
+
+cat <<EOF >overlap-foobar.morph
+{
+ "name": "overlap-foobar",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/usr/bin \$DESTDIR/bin",
+ "echo echo foobar >\$DESTDIR/usr/bin/foobar",
+ "ln -s /usr/bin/foobar \$DESTDIR/bin/foo",
+ "ln -s /usr/bin/foobar \$DESTDIR/bin/bar"
+ ]
+}
+EOF
+
+cat <<EOF >overlap-fooqux.morph
+{
+ "name": "overlap-fooqux",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/usr/bin \$DESTDIR/bin",
+ "for f in qux fooqux; do echo echo \$f >\$DESTDIR/usr/bin/\$f; done",
+ "ln -s /usr/bin/fooqux \$DESTDIR/bin/foo"
+ ]
+}
+EOF
+git add overlap-*.morph
+
+git commit --quiet -m 'Add overlapping chunks'
+
+"$SRCDIR/scripts/test-morph" \
+ build --verbose --log=$log test:morphs-repo overlap overlap-stratum.morph
+grep WARNING $log | sed 's/^.*WARNING/WARNING/'
+(cd "$cache" && ls *.chunk.* *.stratum.* | sed 's/^[^.]*\./ /' |
+ LC_ALL=C sort)
diff --git a/tests/stratum-overlap.stdout b/tests/stratum-overlap.stdout
new file mode 100644
index 00000000..90913dd4
--- /dev/null
+++ b/tests/stratum-overlap.stdout
@@ -0,0 +1,20 @@
+Build starts
+Building test:morphs-repo overlap overlap-stratum.morph
+Figuring out the right build order
+Cloning/updating test:chunk-repo
+Cloning/updating test:chunk-repo
+Cloning/updating test:chunk-repo
+Cloning/updating test:morphs-repo
+Building overlap-foo-baz
+Building overlap-foobar
+Building overlap-fooqux
+Building overlap-stratum
+WARNING Overlaps in artifact overlap-stratum detected
+WARNING Artifacts overlap-foo-baz, overlap-foobar overlap with files:
+WARNING bin/bar
+WARNING Artifacts overlap-foo-baz, overlap-foobar, overlap-fooqux overlap with files:
+WARNING bin/foo
+ chunk.overlap-foo-baz
+ chunk.overlap-foobar
+ chunk.overlap-fooqux
+ stratum.overlap-stratum